%define Werror_cflags %nil
# Modules always contain just 32-bit code
%define _libdir %{_exec_prefix}/lib
%ifarch	x86_64
# 64bit intel machines use 32bit boot loader
# (We cannot just redefine _target_cpu, as we'd get i386.rpm packages)
%global _target_platform i386-%{_vendor}-%{_target_os}%{?_gnu}
%global efi_arch x86_64-efi
%else
%global efi_arch i386-efi
%endif

%global pc_arch i386-pc

%global tarversion 2.02
%define git	10463

Name:		grub2
Version:	2.02.0
Release:	%mkrel 3
Summary:	Boot-loader with support for Linux, Multiboot and more
Group:		System/Kernel and hardware
License:	GPLv3+ and GPLv2
URL:		http://www.gnu.org/software/grub/
Source0:	ftp://ftp.gnu.org/gnu/grub/grub-%{tarversion}.tar.xz
Source2:	grub.default.pclinuxos
Source3:	gitignore
Source4:	grub.patches
Source5:	grub2.filter
Source6:	grub2.script
Source8:	mkfonts
Source9:	unicode.pf2
#
# Fedora patches:
#
# Include Fedora patches in Source7
%{expand:%(while read line; do echo $line; done < %{SOURCE4})}

# And these are:
# git checkout debuginfo
# git format-patch fedora-23..
Patch10001:	10001-Put-the-correct-.file-directives-in-our-.S-files.patch
Patch10002:	10002-Make-it-possible-to-enabled-build-id-sha1.patch
Patch10004:	10004-Add-grub_qdprintf-grub_dprintf-without-the-file-lin.patch
###Patch10005:	10005-Make-a-gdb-dprintf-that-tells-us-load-addresses.patch

#
# Mga patches:
#
Patch20001:	grub2-2.00-mga-add_failsafe-10_linux.in.patch
Patch20002:	grub2-2.00-mga-dont_write_sparse_file_error_to_screen.patch
Patch20003:	grub2-2.00-mga-dont_write_diskfilter_error_to_screen.patch
Patch20004:	grub2-2.00-mga-dont_check_uuid_in_installer.patch
Patch20005:	grub2-2.00-mga-remove-unrestricted_when_password_set.patch
#
# SuSE Patch:
#
# Fixes Mga#15846 - Grub2 doesn't install the bootloader on btrfs if we
# have a dualboot with windows starting at sector 63
Patch30001:	grub2-setup-try-fs-embed-if-mbr-gap-too-small.patch
#
Patch40001:     dont-use-linuxefi-variants.patch
Patch40002:     exclude-duplicate-kernel-entries.patch
Patch40003:     detect-early-microcode-updates.patch

BuildRequires:	flex
BuildRequires:	bison
BuildRequires:	ruby
BuildRequires:	binutils
BuildRequires:  git
BuildRequires:  librpm-devel
BuildRequires:	glibc-static-devel
BuildRequires:	ncurses-devel
BuildRequires:	liblzo-devel
BuildRequires:	freetype2-devel
BuildRequires:	libusb-devel
BuildRequires:	help2man
BuildRequires:	texinfo
BuildRequires:	libdevmapper-devel
BuildRequires:	fuse-devel
BuildRequires:	autogen

Requires:	os-prober
Provides:	bootloader
Provides:	grub2bootloader
Requires:	grub2-theme-pclinuxos
# Minimum version that includes /etc/os-release
Requires(pre):       pclinuxos-release >= 2017-2pclos2017

%description
This is the second version of the GRUB (Grand Unified Boot-loader), a highly
configurable and customizable boot-loader with modular architecture.
It supports a wide range of kernel formats, file systems, computer
architectures and hardware devices. It may be safely installed alongside
legacy grub.

%package efi
Summary:	Boot-loader with support for EFI
Group:		System/Kernel and hardware
Requires:	%{name}
Requires:	efibootmgr
Requires: 	efivar

%description efi
This is the second version of the GRUB (Grand Unified Boot-loader), a highly
configurable and customizable boot-loader with modular architecture.
It supports a wide range of kernel formats, file systems, computer
architectures and hardware devices. It may be safely installed alongside
legacy grub.  This subpackage provides support for EFI systems.

%prep
%setup -q -n grub-%{tarversion}

cp %{SOURCE3} .gitignore
git init
echo '![[:digit:]][[:digit:]]_*.in' > util/grub.d/.gitignore
echo '!*.[[:digit:]]' > util/.gitignore
git config user.email "%{name}-owner@fedoraproject.org"
git config user.name "Fedora Ninjas"
git config gc.auto 0
git add .
git commit -a -q -m "%{tarversion} baseline."
git apply %{patches} </dev/null
git config --unset user.email
git config --unset user.name

cd ..
rm -rf grub-efi-%{tarversion}
mv grub-%{tarversion} grub-efi-%{tarversion}

%setup -q -n grub-%{tarversion}

cp %{SOURCE3} .gitignore
git init
echo '![[:digit:]][[:digit:]]_*.in' > util/grub.d/.gitignore
echo '!*.[[:digit:]]' > util/.gitignore
git config user.email "%{name}-owner@fedoraproject.org"
git config user.name "Fedora Ninjas"
git config gc.auto 0
git add .
git commit -a -q -m "%{tarversion} baseline."
git apply %{patches} </dev/null
git config --unset user.email
git config --unset user.name
find . -name "*.0???" -delete

%build
cd ..
pushd grub-%{tarversion}
./autogen.sh
%configure2_5x TARGET_LDFLAGS=-static			\
%ifarch %arm
	  --with-platform=uboot				\
%else
	 --with-platform=pc				\
%endif
	  --disable-werror				\
	  --enable-grub-mkfont				\
	  --program-transform-name=s,grub,%{name},	\
	  --with-bootdir=/boot				\
	  --with-grubdir=/%{name}			\
	  CFLAGS="-g"
%make_build
popd

pushd grub-efi-%{tarversion}
./autogen.sh
%configure2_5x TARGET_LDFLAGS=-static			\
	  --with-platform=efi				\
%ifarch x86_64
	  --target=x86_64				\
%endif
	  --disable-werror				\
	  --enable-grub-mkfont				\
	  --program-transform-name=s,grub,%{name},	\
	  --with-bootdir=/boot				\
	  --with-grubdir=/%{name}			\
	  CFLAGS="-g"
%make_build
popd

%install
cd ..
pushd grub-efi-%{tarversion}
%make_install
popd

pushd grub-%{tarversion}
%make_install

# (bor) grub.info is harcoded in sources
mv %{buildroot}%{_infodir}/grub.info %{buildroot}%{_infodir}/%{name}.info

# Font
install -d %{buildroot}/boot/%{name}/fonts
install -D %{SOURCE9} %{buildroot}/boot/%{name}/fonts

install -d %{buildroot}/boot/%{name}/themes

# Ghost config files
install -d %{buildroot}/boot/%{name}
touch %{buildroot}/boot/%{name}/grub.cfg

# Workaround for RHL Bug 817187
install -d %{buildroot}%{_datadir}/locale/en/LC_MESSAGES
ln -s %{_datadir}/locale/en@quot/LC_MESSAGES/grub.mo %{buildroot}%{_datadir}/locale/en/LC_MESSAGES/grub.mo

cat > %{buildroot}/boot/%{name}/custom.cfg <<EOF
# Set non-graphical text/background colours
set menu_color_normal=cyan/blue
set menu_color_highlight=white/blue

# Add any extra custom menu entries in here:

EOF

# Provide 'update-grub' and update-grub2 symlink for *buntu exiles ;) 
cat > %{buildroot}%{_bindir}/update-grub <<EOF
#!/bin/sh
su --login root -c "/usr/sbin/grub2-mkconfig -o /boot/grub2/grub.cfg"

EOF
chmod +x %{buildroot}%{_bindir}/update-grub
ln -s %{_bindir}/update-grub %{buildroot}%{_bindir}/update-grub2

# Filetriggers
install -d %{buildroot}/%{_filetriggers_dir}
install -D %{SOURCE5} %{buildroot}/%{_filetriggers_dir}/%{name}.filter
install -D %{SOURCE6} %{buildroot}/%{_filetriggers_dir}/%{name}.script

# Defaults
install -m 644 -D %{SOURCE2} %{buildroot}%{_sysconfdir}/default/grub

# Remove "GNU/Linux" in menu selections
sed -i 's/ GNU\/Linux//' %{buildroot}%{_sysconfdir}/grub.d/10_linux

#remove startfield theme
rm -rf %{buildroot}/%{_datadir}/grub/themes/starfield


%find_lang grub

popd


%post
if [ $1 -eq 2 ]; then
      touch /boot/grub2/updtrans
fi

%post efi
if [ $1 -eq 2 ]; then
      touch /boot/grub2/updtrans-efi
fi

%posttrans 
# On update re-install grub2 to where it was installed by drakboot if possible,
# otherwise next boot may fail due to mismatched boot code.
   if [ -f /boot/grub2/updtrans ] && [ -f /boot/grub2/install.sh -a -x /usr/sbin/detectloader ] && [ "$DURING_INSTALL" != "1" ] ; then
		LOADER=$(/usr/sbin/detectloader)
		[ "$LOADER" = "GRUB2" ] && /boot/grub2/install.sh ||:
		rm -f /boot/grub2/updtrans
   fi


%posttrans efi
# On update re-install grub2 to where it was installed by drakboot if possible,
# otherwise next boot may fail due to mismatched boot code.
   if [ -f /boot/grub2/updtrans-efi ] && [ -f /boot/grub2/install.sh -a -x /usr/sbin/detectloader ] && [ "$DURING_INSTALL" != "1" ] ; then
		LOADER=$(/usr/sbin/detectloader)
		[ "$LOADER" = "GRUB2" ] && /boot/grub2/install.sh ||:
		rm -f /boot/grub2/updtrans-efi
   fi   
   

%preun
exec > /var/log/%{name}_preun.log 2>&1
# Only if uninstalling
if [ $1 -eq 0 ]; then
rm -rf /boot/%{name}/%{pc_arch}
rm -rf /boot/%{name}/locale
fi

%preun efi
exec > /var/log/%{name}_preun.log 2>&1
# Only if uninstalling
if [ $1 -eq 0 ]; then
rm -rf /boot/%{name}/%{efi_arch}
rm -rf /boot/%{name}/locale
fi

%triggerpostun efi -- %{name}-efi < 2.02
%{name}-mkconfig -o /boot/%{name}/grub.cfg


%files
%defattr(-,root,root,-)
%{_infodir}/*
%dir %{_libdir}/grub
%dir %{_libdir}/grub/i386-pc
%dir /boot/%{name}
%dir /boot/%{name}/fonts
%dir /boot/%{name}/themes
%{_libdir}/grub/i386-pc/*
%{_bindir}/%{name}-*
%{_bindir}/update-grub
%{_bindir}/update-grub2
%{_sbindir}/%{name}-*
%{_datadir}/bash-completion/completions/grub
%{_sysconfdir}/grub.d/README
%{_sysconfdir}/grub.d/00_header
%{_sysconfdir}/grub.d/01_users
%{_sysconfdir}/grub.d/10_linux
%{_sysconfdir}/grub.d/20_linux_xen
%{_sysconfdir}/grub.d/20_ppc_terminfo
%{_sysconfdir}/grub.d/30_os-prober
%config(noreplace) %{_sysconfdir}/grub.d/40_custom
%config(noreplace) %{_sysconfdir}/grub.d/41_custom
%{_datadir}/grub
%config(noreplace) /boot/%{name}/grub.cfg
%config(noreplace) /boot/%{name}/custom.cfg
%{_mandir}/man1/%{name}-*.1*
%{_mandir}/man8/%{name}-*.8*
%{_filetriggers_dir}/%{name}.filter
%{_filetriggers_dir}/%{name}.script

#dont replace this on update
%config(noreplace) %{_sysconfdir}/default/grub

#goes in theme package
%exclude /boot/grub2/fonts/unicode.pf2
%{_datadir}/locale


%files efi
%defattr(-,root,root,-)
%dir %{_libdir}/grub
%dir %{_libdir}/grub/%{efi_arch}
%{_libdir}/grub/%{efi_arch}/*

%changelog
* Sat Nov 04 2017 Conan Kudo <Conan Kudo> - 2.02.0-3pclos2017
- Drop os-release file, as it's now part of pclinuxos-release

* Thu Nov 02 2017 bb2 <bb2> - 2.02.0-2pclos2017
- apply detect-early-microcode-updates.patch

* Wed Nov 01 2017 bb2 <bb2> - 2.02.0-1pclos2017
- apply grub2 exclude duplicate kernel entries patch

* Mon Oct 30 2017 bb2 <bb2> - 2.02-12pclos2017
- update to 2.02 final

* Sun Jul 09 2017 TerryN <terryn94 at gmail.com> 2.02-11pclos2017
- fix update-grub2 making linuxefi/initrdefi entries

* Thu Jul 06 2017 bb2 <bb2> - 2.02-10pclos2017
- add posttrans scripts

* Thu Jul 06 2017 bb2 <bb2> - 2.02-9pclos2017
- try adjusted build

* Tue Jul 04 2017 bb2 <bb2> - 2.02-8pclos2017
- add os-release file

* Tue Jul 04 2017 bb2 <bb2> 2.02-7pclos2017
- update source code with patches
- drop 42_efi

* Sun May 10 2015 bb <bb> 2.02-6pclos2015
- add windows efi support

* Mon Apr 27 2015 TerryN <terryn94 at gmail.com> 2.02-3pclos2015
- grub2/grub2-efi no longer conflict

* Fri Apr 10 2015 bb <bb> 2.02-2pclos2015
- update postscripts
- add theme dependency

* Thu Apr 02 2015 bb <bb> 2.02-1pclos2015
- update from git with patches applied

* Sat Jun 21 2014 bb <bb> 2.00-3pclos2014
- change /etc/default/grub so plymouth works on pclos

* Fri Jun 20 2014 bb <bb> 2.00-2pclos2014
- fix post script for pclos

* Fri May 23 2014 bb <bb> 2.00-1pclos2014
- import into pclos
